#ifdef STATISTICS
/*
 * $Id$
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Generic/Queue/include/Statistics.h"

#include <sstream>
using namespace std;

namespace morpheo {
namespace behavioural {
namespace generic {
namespace queue {


#undef  FUNCTION
#define FUNCTION "Queue::print"
  string Statistics::print (uint32_t depth)
  {
    log_printf(FUNC,Queue,FUNCTION,"Begin");

    string        tab = string(depth,'\t');
    ostringstream msg;

    msg << tab << "<queue name=\"" << _name << "\" >" << endl
        << print_body(depth+1) << endl
	<< tab << "</queue>" << endl;
    
    log_printf(FUNC,Queue,FUNCTION,"End");

    return msg.str();
  };

#undef  FUNCTION
#define FUNCTION "Queue::operator<<"
  ostream& operator<< (ostream& output_stream ,
		       morpheo::behavioural::generic::queue::Statistics & x)
  {
    log_printf(FUNC,Queue,FUNCTION,"Begin");

    output_stream << x.print(0);

    log_printf(FUNC,Queue,FUNCTION,"End");

    return output_stream;
  };

}; // end namespace queue
}; // end namespace generic

}; // end namespace behavioural
}; // end namespace morpheo              
#endif
